/*
  Copyright (c) 2012-2015, Matthias Schiffer <mschiffer@universe-factory.net>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/**
   \file

   Generated list of supported method providers
*/


#include <src/method.h>



extern const fastd_method_provider_t fastd_method_null;
extern const fastd_method_provider_t fastd_method_cipher_test;
extern const fastd_method_provider_t fastd_method_composed_gmac;
extern const fastd_method_provider_t fastd_method_composed_umac;
extern const fastd_method_provider_t fastd_method_generic_gmac;
extern const fastd_method_provider_t fastd_method_generic_poly1305;
extern const fastd_method_provider_t fastd_method_generic_umac;
extern const fastd_method_provider_t fastd_method_xsalsa20_poly1305;

/** The list of method providers */
static const fastd_method_provider_t *const providers[] = { 
&fastd_method_null,
&fastd_method_cipher_test,
&fastd_method_composed_gmac,
&fastd_method_composed_umac,
&fastd_method_generic_gmac,
&fastd_method_generic_poly1305,
&fastd_method_generic_umac,
&fastd_method_xsalsa20_poly1305,
};


bool fastd_method_create_by_name(const char *name, const fastd_method_provider_t **provider, fastd_method_t **method) {
	size_t i;
	for (i = 0; i < array_size(providers); i++) {
		if (providers[i]->create_by_name(name, method)) {
			*provider = providers[i];
			return true;
		}
	}

	return false;
}
